/*****************************************************************************/
/* 16xhh.c                                                                   */
/* 16x?? decoder module                                                      */
/* (c) 2000 Jay                                                              */
/*****************************************************************************/
#include "dm.h"

void startup()
{
   /* assign default help page */
   export.help = SystemHelp;
}

int tile_pack(unsigned char *dest,const unsigned char *src,int width,int height)
{
   asm volatile ("
      movl %1, %%edi;
      movl %2, %%esi;
      movl %0, %%ecx;

0:    movl $16, %%edx;
1:    movb (%%esi), %%al;

      shrb $1, %%al;
      rclw $1, (%%edi)

      incl %%esi;

      decl %%edx;
      jnz 1b;

      movw (%%edi), %%ax;
      xchgb %%al, %%ah;
      movw %%ax, (%%edi);

      addl $2, %%edi;

      decl %%ecx;
      jnz 0b;"

      : : "g" (height), "g" (dest), "g" (src)
      : "%eax", "%ecx", "%edx", "%edi", "%esi"
   );

   return height * 2;
}

int tile_unpack(unsigned char *dest,const unsigned char *src,int width,int height)
{
   asm volatile ("
      movl %1, %%edi;
      movl %2, %%esi;
      movl %0, %%ecx;

0:    movw (%%esi), %%ax;
      xchgb %%al, %%ah;   // swap order

      shlw $1, %%ax;
      setcb (%%edi);
      shlw $1, %%ax;
      setcb 1(%%edi);
      shlw $1, %%ax;
      setcb 2(%%edi);
      shlw $1, %%ax;
      setcb 3(%%edi);
      shlw $1, %%ax;
      setcb 4(%%edi);
      shlw $1, %%ax;
      setcb 5(%%edi);
      shlw $1, %%ax;
      setcb 6(%%edi);
      shlw $1, %%ax;
      setcb 7(%%edi);
      shlw $1, %%ax;
      setcb 8(%%edi);
      shlw $1, %%ax;
      setcb 9(%%edi);
      shlw $1, %%ax;
      setcb 10(%%edi);
      shlw $1, %%ax;
      setcb 11(%%edi);
      shlw $1, %%ax;
      setcb 12(%%edi);
      shlw $1, %%ax;
      setcb 13(%%edi);
      shlw $1, %%ax;
      setcb 14(%%edi);
      shlw $1, %%ax;
      setcb 15(%%edi);

      addl $2, %%esi;
      addl $16, %%edi;

      decl %%ecx;
      jnz 0b;"

      : : "g" (height), "g" (dest), "g" (src)
      : "%eax", "%ecx", "%edi", "%esi"
   );

   return height * 2;
}

/* you must define an EXPORTSTRUC with 'export' in order to export data */
static EXPORTSTRUC export =
{
/*entry*/         startup,
/*tile_pack*/     tile_pack,
/*tile_unpack*/   tile_unpack,
/*update*/        NULL,
/*save*/          NULL,
/*minwidth*/      16,
/*minheight*/     1,
/*maxwidth*/      16,
/*maxheight*/     16,
/*bpp*/           1,
/*maxpal*/        2,
/*modestr*/       "16x?? Decoder",
/*help*/          NULL,
/*key*/           { 0, 0, 0, 0 },
/*KeyHandler*/    { NULL, NULL, NULL, NULL }
};